import { ICommand, IInjector, IContext } from "@robotlegsjs/core";
import { IMacro } from "../api/IMacro";
import { ISubCommandMapping } from "../api/ISubCommandMapping";
import { ISubCommandPayload } from "../api/ISubCommandPayload";
import { ISubCommandConfigurator } from "../dsl/ISubCommandConfigurator";
import { AsyncCommand } from "./AsyncCommand";
import { SubCommandMappingList } from "./SubCommandMappingList";
export declare abstract class AbstractMacro extends AsyncCommand implements IMacro {
    protected _injector: IInjector;
    protected _mappings: SubCommandMappingList;
    constructor(context: IContext, injector: IInjector);
    add(commandClass: any): ISubCommandConfigurator;
    addInstance(command: ICommand): ISubCommandConfigurator;
    remove(commandClass: any): void;
    abstract prepare(): void;
    protected executeCommand(mapping: ISubCommandMapping): void;
    protected mapPayloads(payloads: ISubCommandPayload[]): void;
    protected unmapPayloads(payloads: ISubCommandPayload[]): void;
    protected abstract commandCompleteHandler(success: boolean): void;
}
