"use strict";
// ------------------------------------------------------------------------------
//  2017 RobotlegsJS. All Rights Reserved.
//
//  NOTICE: You are permitted to use, modify, and distribute this file
//  in accordance with the terms of the license agreement accompanying it.
// ------------------------------------------------------------------------------
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@robotlegsjs/core");
var AsyncCommand = /** @class */ (function () {
    function AsyncCommand(context) {
        this._listeners = [];
        this._context = context;
    }
    AsyncCommand.prototype.registerCompleteCallback = function (listener) {
        this._listeners.unshift(listener);
    };
    AsyncCommand.prototype.execute = function () {
        this._context.detain(this);
    };
    AsyncCommand.prototype.dispatchComplete = function (success) {
        this._context.release(this);
        for (var i = 0; i < this._listeners.length; i++) {
            var listener = this._listeners[i];
            if (listener.length === 0) {
                listener();
            }
            else {
                listener(success);
            }
        }
        if (this._listeners) {
            this._listeners = null;
        }
    };
    AsyncCommand = __decorate([
        core_1.injectable(),
        __param(0, core_1.inject(core_1.IContext)),
        __metadata("design:paramtypes", [Object])
    ], AsyncCommand);
    return AsyncCommand;
}());
exports.AsyncCommand = AsyncCommand;
//# sourceMappingURL=AsyncCommand.js.map