"use strict";
// ------------------------------------------------------------------------------
//  2017 RobotlegsJS. All Rights Reserved.
//
//  NOTICE: You are permitted to use, modify, and distribute this file
//  in accordance with the terms of the license agreement accompanying it.
// ------------------------------------------------------------------------------
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AbstractMacro_1 = require("./AbstractMacro");
var ParallelMacro = /** @class */ (function (_super) {
    __extends(ParallelMacro, _super);
    function ParallelMacro() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._executionCount = 0;
        _this._success = true;
        _this._running = false;
        return _this;
    }
    ParallelMacro.prototype.execute = function () {
        _super.prototype.execute.call(this);
        this._commands = this._mappings.getList();
        if (this.hasCommands) {
            this._running = true;
            for (var i = 0; i < this._commands.length; i++) {
                var mapping = this._commands[i];
                if (!this._success) {
                    break;
                }
                this.executeCommand(mapping);
            }
        }
        else {
            this.dispatchComplete(true);
        }
    };
    Object.defineProperty(ParallelMacro.prototype, "hasCommands", {
        get: function () {
            return this._mappings && this._commands.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    ParallelMacro.prototype.commandCompleteHandler = function (success) {
        this._executionCount++;
        this._success = this._success && success;
        if (this._running && (!this._success || this._executionCount === this._commands.length)) {
            this.dispatchComplete(this._success);
        }
    };
    ParallelMacro.prototype.dispatchComplete = function (success) {
        this._running = false;
        this._success = true;
        this._executionCount = 0;
        this._commands = null;
        _super.prototype.dispatchComplete.call(this, success);
    };
    return ParallelMacro;
}(AbstractMacro_1.AbstractMacro));
exports.ParallelMacro = ParallelMacro;
//# sourceMappingURL=ParallelMacro.js.map