"use strict";
// ------------------------------------------------------------------------------
//  2017 RobotlegsJS. All Rights Reserved.
//
//  NOTICE: You are permitted to use, modify, and distribute this file
//  in accordance with the terms of the license agreement accompanying it.
// ------------------------------------------------------------------------------
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@robotlegsjs/core");
var SubCommandMapping = /** @class */ (function () {
    function SubCommandMapping(commandClass) {
        this._executeMethod = "execute";
        this._guards = [];
        this._payloads = [];
        this._hooks = [];
        this._commandClass = commandClass;
    }
    Object.defineProperty(SubCommandMapping.prototype, "commandClass", {
        get: function () {
            return this._commandClass;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubCommandMapping.prototype, "executeMethod", {
        get: function () {
            return this._executeMethod;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubCommandMapping.prototype, "guards", {
        get: function () {
            return this._guards.slice();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubCommandMapping.prototype, "hooks", {
        get: function () {
            return this._hooks.slice();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubCommandMapping.prototype, "payloads", {
        get: function () {
            return this._payloads.slice();
        },
        enumerable: true,
        configurable: true
    });
    SubCommandMapping.prototype.withGuards = function () {
        var guards = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            guards[_i] = arguments[_i];
        }
        this._guards = this._guards.concat(guards);
        return this;
    };
    SubCommandMapping.prototype.withHooks = function () {
        var hooks = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            hooks[_i] = arguments[_i];
        }
        this._hooks = this._hooks.concat(hooks);
        return this;
    };
    SubCommandMapping.prototype.withPayloads = function () {
        var payloads = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            payloads[_i] = arguments[_i];
        }
        for (var i = 0; i < payloads.length; i++) {
            var payload = payloads[i];
            this._payloads.push(payload);
        }
        return this;
    };
    SubCommandMapping.prototype.withExecuteMethod = function (name) {
        this._executeMethod = name;
        return this;
    };
    SubCommandMapping.prototype.getOrCreateCommandInstance = function (injector) {
        return core_1.instantiateUnmapped(injector, this.commandClass);
    };
    return SubCommandMapping;
}());
exports.SubCommandMapping = SubCommandMapping;
//# sourceMappingURL=SubCommandMapping.js.map